---
title: Pull Queue Messages
---

[Skip to content](#_top)

[API Reference](https://developers.cloudflare.com/api/go)

[Queues](https://developers.cloudflare.com/api/go/resources/queues)

[Messages](https://developers.cloudflare.com/api/go/resources/queues/subresources/messages)

Copy Markdown

Open in **Claude**Open in **ChatGPT**Open in **Cursor**

---

**Copy Markdown****View as Markdown**

# Pull Queue Messages

client.Queues.Messages.Pull(ctx, queueID, params) (\*[MessagePullResponse](<https://developers.cloudflare.com/api/go/resources/queues#(resource)%20queues.messages%20%3E%20(model)%20MessagePullResponse%20%3E%20(schema)>), error)

POST/accounts/{account\_id}/queues/{queue\_id}/messages/pull

Pulls a batch of messages from a Queue for an HTTP pull consumer.

##### Security

<details>

<summary>API Token</summary>



The preferred authorization scheme for interacting with the Cloudflare API. <a href="https://developers.cloudflare.com/fundamentals/api/get-started/create-token/">Create a token</a>.

**Example:**<code>Authorization: Bearer Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY</code>

</details>

<details>

<summary>API Email + API Key</summary>



The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

**Example:**<code>X-Auth-Email: user@example.com</code>

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

**Example:**<code>X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194</code>

</details>

##### Accepted Permissions (at least one required)

`Queues Write``Workers Scripts Write`

##### ParametersExpand Collapse

queueID string

A Resource identifier.

maxLength32

[Link to this property](<#(resource)%20queues.messages%20%3E%20(method)%20pull%20%3E%20(params)%20default%20%3E%20(param)%20queue_id%20%3E%20(schema)>)

<details>

<summary>

params MessagePullParams

</summary>

AccountID param.Field\[string]

Path param: A Resource identifier.

maxLength32

<a href="#(resource)%20queues.messages%20%3E%20(method)%20pull%20%3E%20(params)%20default%20%3E%20(param)%20account_id">Link to this property</a>

BatchSize param.Field\[float64]Optional

Body param: The maximum number of messages to include in a batch.

<a href="#(resource)%20queues.messages%20%3E%20(method)%20pull%20%3E%20(params)%20default%20%3E%20(param)%20batch_size">Link to this property</a>

VisibilityTimeoutMs param.Field\[float64]Optional

Body param: The number of milliseconds that a message is exclusively leased. After the timeout, the message becomes available for another attempt.

<a href="#(resource)%20queues.messages%20%3E%20(method)%20pull%20%3E%20(params)%20default%20%3E%20(param)%20visibility_timeout_ms">Link to this property</a>

</details>

[Link to this property](<#(resource)%20queues.messages%20%3E%20(method)%20pull%20%3E%20(params)%20default>)

##### ReturnsExpand Collapse

<details>

<summary>

type MessagePullResponse struct{…}

</summary>

MessageBacklogCount float64Optional

The number of unacknowledged messages in the queue.

<a href="#(resource)%20queues.messages%20%3E%20(model)%20MessagePullResponse%20%3E%20(schema)%20%3E%20(property)%20message_backlog_count">Link to this property</a>

<details>

<summary>

Messages \[]MessagePullResponseMessageOptional

</summary>

ID stringOptional

<a href="#(resource)%20queues.messages%20%3E%20(model)%20MessagePullResponse%20%3E%20(schema)%20%3E%20(property)%20messages%20%3E%20(items)%20%3E%20(property)%20id">Link to this property</a>

Attempts float64Optional

<a href="#(resource)%20queues.messages%20%3E%20(model)%20MessagePullResponse%20%3E%20(schema)%20%3E%20(property)%20messages%20%3E%20(items)%20%3E%20(property)%20attempts">Link to this property</a>

Body stringOptional

<a href="#(resource)%20queues.messages%20%3E%20(model)%20MessagePullResponse%20%3E%20(schema)%20%3E%20(property)%20messages%20%3E%20(items)%20%3E%20(property)%20body">Link to this property</a>

LeaseID stringOptional

An ID that represents an “in-flight” message that has been pulled from a Queue. You must hold on to this ID and use it to acknowledge this message.

<a href="#(resource)%20queues.messages%20%3E%20(model)%20MessagePullResponse%20%3E%20(schema)%20%3E%20(property)%20messages%20%3E%20(items)%20%3E%20(property)%20lease_id">Link to this property</a>

Metadata unknownOptional

<a href="#(resource)%20queues.messages%20%3E%20(model)%20MessagePullResponse%20%3E%20(schema)%20%3E%20(property)%20messages%20%3E%20(items)%20%3E%20(property)%20metadata">Link to this property</a>

TimestampMs float64Optional

<a href="#(resource)%20queues.messages%20%3E%20(model)%20MessagePullResponse%20%3E%20(schema)%20%3E%20(property)%20messages%20%3E%20(items)%20%3E%20(property)%20timestamp_ms">Link to this property</a>

</details>

<a href="#(resource)%20queues.messages%20%3E%20(model)%20MessagePullResponse%20%3E%20(schema)%20%3E%20(property)%20messages">Link to this property</a>

<details>

<summary>

Metadata MessagePullResponseMetadataOptional

</summary>

<details>

<summary>

Metrics MessagePullResponseMetadataMetricsOptional

Best-effort metrics for the queue. Values may be approximate due to the distributed nature of queues.

</summary>

BacklogBytes float64

The size in bytes of unacknowledged messages in the queue.

<a href="#(resource)%20queues.messages%20%3E%20(model)%20MessagePullResponse%20%3E%20(schema)%20%3E%20(property)%20metadata%20%3E%20(property)%20metrics%20%3E%20(property)%20backlog_bytes">Link to this property</a>

BacklogCount float64

The number of unacknowledged messages in the queue.

<a href="#(resource)%20queues.messages%20%3E%20(model)%20MessagePullResponse%20%3E%20(schema)%20%3E%20(property)%20metadata%20%3E%20(property)%20metrics%20%3E%20(property)%20backlog_count">Link to this property</a>

OldestMessageTimestampMs float64

Unix timestamp in milliseconds of the oldest unacknowledged message in the queue. Returns 0 if unknown.

<a href="#(resource)%20queues.messages%20%3E%20(model)%20MessagePullResponse%20%3E%20(schema)%20%3E%20(property)%20metadata%20%3E%20(property)%20metrics%20%3E%20(property)%20oldest_message_timestamp_ms">Link to this property</a>

</details>

<a href="#(resource)%20queues.messages%20%3E%20(model)%20MessagePullResponse%20%3E%20(schema)%20%3E%20(property)%20metadata%20%3E%20(property)%20metrics">Link to this property</a>

</details>

<a href="#(resource)%20queues.messages%20%3E%20(model)%20MessagePullResponse%20%3E%20(schema)%20%3E%20(property)%20metadata">Link to this property</a>

</details>

[Link to this property](<#(resource)%20queues.messages%20%3E%20(model)%20MessagePullResponse%20%3E%20(schema)>)

### Pull Queue Messages

Go

HTTPTypeScriptPythonGoTerraform

```
package main

import (
  "context"
  "fmt"

  "github.com/cloudflare/cloudflare-go"
  "github.com/cloudflare/cloudflare-go/option"
  "github.com/cloudflare/cloudflare-go/queues"
)

func main() {
  client := cloudflare.NewClient(
    option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"),
  )
  response, err := client.Queues.Messages.Pull(
    context.TODO(),
    "023e105f4ecef8ad9ca31a8372d0c353",
    queues.MessagePullParams{
      AccountID: cloudflare.F("023e105f4ecef8ad9ca31a8372d0c353"),
    },
  )
  if err != nil {
    panic(err.Error())
  }
  fmt.Printf("%+v\n", response.MessageBacklogCount)
}
```

200 example

```
{
  "errors": [
    {
      "code": 7003,
      "message": "No route for the URI",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    "string"
  ],
  "result": {
    "message_backlog_count": 5,
    "messages": [
      {
        "id": "b01b5594f784d0165c2985833f5660dd",
        "attempts": 1,
        "body": "hello world",
        "lease_id": "eyJhbGciOiJkaXIiLCJlbmMiOiJBMjU2Q0JDLUhTNTEyIn0..Q8p21d7dceR6vUfwftONdQ.JVqZgAS-Zk7MqmqccYtTHeeMElNHaOMigeWdb8LyMOg.T2_HV99CYzGaQuhTyW8RsgbnpTRZHRM6N7UoSaAKeK0",
        "metadata": {
          "CF-Content-Type": "text",
          "CF-sourceMessageSource": "dash"
        },
        "timestamp_ms": 1710950954154
      }
    ],
    "metadata": {
      "metrics": {
        "backlog_bytes": 1024,
        "backlog_count": 5,
        "oldest_message_timestamp_ms": 1710950954154
      }
    }
  },
  "success": true
}
```

##### Returns Examples

200 example

```
{
  "errors": [
    {
      "code": 7003,
      "message": "No route for the URI",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    "string"
  ],
  "result": {
    "message_backlog_count": 5,
    "messages": [
      {
        "id": "b01b5594f784d0165c2985833f5660dd",
        "attempts": 1,
        "body": "hello world",
        "lease_id": "eyJhbGciOiJkaXIiLCJlbmMiOiJBMjU2Q0JDLUhTNTEyIn0..Q8p21d7dceR6vUfwftONdQ.JVqZgAS-Zk7MqmqccYtTHeeMElNHaOMigeWdb8LyMOg.T2_HV99CYzGaQuhTyW8RsgbnpTRZHRM6N7UoSaAKeK0",
        "metadata": {
          "CF-Content-Type": "text",
          "CF-sourceMessageSource": "dash"
        },
        "timestamp_ms": 1710950954154
      }
    ],
    "metadata": {
      "metrics": {
        "backlog_bytes": 1024,
        "backlog_count": 5,
        "oldest_message_timestamp_ms": 1710950954154
      }
    }
  },
  "success": true
}
```